JUCE: GenericScopedLock< LockType > Class Template Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
GenericScopedLock< LockType > Class Template Reference
juce_core » threads

Automatically locks and unlocks a mutex object. More...

`#include <juce_ScopedLock.h>`

## Public Member Functions
| GenericScopedLock (const LockType &lock) noexcept
| Creates a GenericScopedLock.
| ~GenericScopedLock () noexcept
| Destructor.

## Detailed Description

template<class LockType>
class GenericScopedLock< LockType >

Automatically locks and unlocks a mutex object.

Use one of these as a local variable to provide RAII-based locking of a mutex.

The templated class could be a CriticalSection, SpinLock, or anything else that provides enter() and exit() methods.

e.g.

CriticalSection myCriticalSection;
for (;;)
{
const GenericScopedLock<CriticalSection> myScopedLock (myCriticalSection);
// myCriticalSection is now locked
...do some stuff...
// myCriticalSection gets unlocked here.
}
CriticalSection
A re-entrant mutex.
Definition juce_CriticalSection.h:44
GenericScopedLock
Automatically locks and unlocks a mutex object.
Definition juce_ScopedLock.h:56

See also
  GenericScopedUnlock, CriticalSection, SpinLock, ScopedLock, ScopedUnlock

## Constructor & Destructor Documentation

## ◆ GenericScopedLock()

template<class LockType >

GenericScopedLock< LockType >::GenericScopedLock | ( | const LockType & | lock | ) |
| explicitnoexcept

Creates a GenericScopedLock.

As soon as it is created, this will acquire the lock, and when the GenericScopedLock object is deleted, the lock will be released.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

## ◆ ~GenericScopedLock()

template<class LockType >

GenericScopedLock< LockType >::~GenericScopedLock | ( |  | ) |
| noexcept

Destructor.

The lock will be released when the destructor is called. Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen!

The documentation for this class was generated from the following file:

- juce_ScopedLock.h